VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2415
   ClientLeft      =   1320
   ClientTop       =   1455
   ClientWidth     =   7815
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2415
   ScaleWidth      =   7815
   Begin VB.TextBox Text2 
      Height          =   2175
      Left            =   3960
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "Form1.frx":0000
      Top             =   240
      Width           =   3855
   End
   Begin VB.TextBox Text1 
      Height          =   2175
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "Form1.frx":0121
      Top             =   240
      Width           =   3855
   End
   Begin VB.Label Label1 
      Caption         =   "Without Undo"
      Height          =   255
      Index           =   1
      Left            =   3960
      TabIndex        =   3
      Top             =   0
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "With Undo"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Cmds As New Collection
Dim LastCmd As Integer

' Add a command to the list.
Private Sub AddCommand(cmd As Object)
    ' Remove any undone commands.
    Do While Cmds.Count > LastCmd
        Cmds.Remove Cmds.Count
    Loop
    
    ' Add the new command.
    Cmds.Add cmd
    LastCmd = Cmds.Count
End Sub
' Redo a command.
Private Sub Redo()
    If LastCmd >= Cmds.Count Then Exit Sub
    LastCmd = LastCmd + 1
    Cmds.Item(LastCmd).Apply
End Sub
' Undo a command.
Private Sub Undo()
    If LastCmd < 1 Then Exit Sub
    Cmds.Item(LastCmd).Undo
    LastCmd = LastCmd - 1
End Sub
Private Sub Form_Resize()
    If WindowState = vbMinimized Then Exit Sub

Dim hgt As Single

    hgt = ScaleHeight - Text1.Top
    If hgt < 120 Then hgt = 120

    Text1.Move 0, Text1.Top, ScaleWidth / 2, hgt
    Text2.Move Text1.Width, Text2.Top, ScaleWidth / 2, hgt
End Sub


Private Sub Text1_KeyPress(KeyAscii As Integer)
Const KeyTilda = 126 ' The ~ character.
Dim cmd As TextCmd

    If KeyAscii = 26 Then       ' ^Z
        Undo
    ElseIf KeyAscii = 25 Then   ' ^Y
        Redo
    ElseIf KeyAscii >= vbKeySpace And _
       KeyAscii <= KeyTilda _
    Then                        ' Some visible key.
        ' Add the new command to Cmds.
        Set cmd = New TextCmd
        AddCommand cmd
        
        ' Give the command the info it needs to work.
        cmd.Initialize Text1, Chr$(KeyAscii)
        
        ' Apply the command.
        cmd.Apply
    End If
    
    ' We processed the character so discard it.
    KeyAscii = 0
End Sub

